/*		Configuration-specific Initialialization	HTSInit.c
**		----------------------------------------
** This file is for a server.
*/

/* Implements: */

#include "HTInit.h"


/*	Define a basic set of suffixes and presentations
**	------------------------------------------------
*/

/* #include "HTML.h"	*/
/* #include "HTPlain.h"	*/

#include "HTMLGen.h"
#include "HTFile.h"
#include "HTFormat.h"

#include "HTMIME.h"
#include "HTWSRC.h"

PUBLIC void HTFormatInit NOARGS
{

 HTSetConversion("www/mime",  "*",  	     HTMIMEConvert, 	1.0, 0.0, 0.0);
 HTSetConversion("application/x-wais-source",
 		      "*",  	     HTWSRCConvert, 	1.0, 0.0, 0.0);
 HTSetConversion("text/plain", "text/html",  HTPlainToHTML,	1.0, 0.0, 0.0);
}



/*	Define a basic set of suffixes
**	------------------------------
**
**	The first suffix for a type is that used for temporary files
**	of that type.
*/

#ifndef NO_INIT
PUBLIC void HTFileInit NOARGS
{
    
    HTSetSuffix(".mime","www/mime", "binary", 1.0);	/* Internal -- MIME is not recursive */
    
    HTSetSuffix(".PS",	"application/postscript", "8bit", 0.8);
    HTSetSuffix(".eps",	"application/postscript", "8bit", 0.8);
    HTSetSuffix(".ai",	"application/postscript", "8bit", 0.5);
    HTSetSuffix(".ps",	"application/postscript", "8bit", 0.8);
    HTSetSuffix(".execme.csh", "application/x-csh", "7bit", 0.5);
    HTSetSuffix(".html","text/html", "8bit", 1.0);

    HTSetSuffix(".c",	"text/plain", "7bit", 0.5);
    HTSetSuffix(".h",	"text/plain", "7bit", 0.5);	/* html better */
    HTSetSuffix(".m",	"text/plain", "7bit", 0.5);	/* Objective-C code */
    HTSetSuffix(".txt", "text/plain", "7bit", 0.5);

    HTSetSuffix(".rtf",	"application/x-rtf", "7bit", 1.0);
    
    HTSetSuffix(".src",	"application/x-wais-source", "7bit", 1.0);
    
    HTSetSuffix(".snd", "audio/basic", "binary", 1.0);
    
    HTSetSuffix(".bin",	"application/octet-stream", "binary", 1.0);	/* @@@@@@@@@@@@@@@@ */

    HTSetSuffix(".Z",	"application/x-compressed", "binary", 1.0);	/* @@@@@@@@@@@@@@@@ */
    
    HTSetSuffix(".gif", "image/gif", "binary", 1.0);

    HTSetSuffix(".tiff","image/x-tiff", "binary", 1.0);
    
    HTSetSuffix(".jpg", "image/jpeg", "binary", 1.0);
    HTSetSuffix(".JPG", "image/jpeg", "binary", 1.0);
    HTSetSuffix(".JPEG","image/jpeg", "binary", 1.0);
    HTSetSuffix(".jpeg","image/jpeg", "binary", 1.0);
    
    HTSetSuffix(".MPEG","video/mpeg", "binary", 1.0);
    HTSetSuffix(".mpg","video/mpeg", "binary", 1.0);
    HTSetSuffix(".MPG","video/mpeg", "binary", 1.0);
    HTSetSuffix(".mpeg","video/mpeg", "binary", 1.0);

}
#endif /* NO_INIT */

